function k3p_cf(f, η1, η2, η3, ξ)

	(ξ^3)*((η1)^2)*(η2)*(

	f((1-ξ, ξ-ξ*η1+ξ*η1*η2), (1-(ξ-ξ*η1*η2*η3), ξ-ξ*η1)) +

	f((1-(ξ-ξ*η1*η2*η3), ξ-ξ*η1), (1-ξ, ξ-ξ*η1+ξ*η1*η2)) +

	f((1-ξ, ξ*η1*(1-η2+η2*η3)), (1-(ξ-ξ*η1*η2), ξ*η1*(1-η2))) +

	f((1-(ξ-ξ*η1*η2), ξ*η1*(1-η2)), (1-ξ, ξ*η1*(1-η2+η2*η3))) +

	f((1-(ξ-ξ*η1*η2*η3), ξ*η1*(1-η2*η3)), (1-ξ, ξ*η1*(1-η2))) +

	f((1-ξ, ξ*η1*(1-η2)), (1-(ξ-ξ*η1*η2*η3), ξ*η1*(1-η2*η3)))

	)
end


function k3p_ce(f, η1, η2, η3, ξ)

	ξη1 = ξ * η1
	η1η2 = η1 * η2
	η2η3 = η2 * η3
	η1η2η3 = η1η2 * η3
	# ξη2 = ξ * η2
	# ξη3 = ξ * η3

	(ξ^3)*((η1)^2) * f((1-ξ, ξη1*η3), (1-ξ*(1-η1η2), ξη1*(1-η2))) +

	(ξ^3)*((η1)^2)*(η2)*(

	f((1-ξ, ξη1), (1-ξ*(1-η1η2η3), ξη1*η2*(1-η3))) +

	f((1-ξ*(1-η1η2), ξη1*(1-η2)), (1-ξ, ξη1*η2η3)) +

	f((1-ξ*(1-η1η2η3), ξη1*η2*(1-η3)), (1-ξ, ξη1)) +

	f((1-ξ*(1-η1η2η3), ξη1*(1-η2η3)), (1-ξ, ξη1*η2))

	)
end


function k3p_cv(f,η1, η2, η3, ξ)

	ξη1 = ξ * η1
	ξη2 = ξ * η2

	(ξ^3)*η2*(

	f((1-ξ, ξη1), (1-ξη2, ξη2*η3)) +  f((1-ξη2, ξη2*η3), (1-ξ, ξη1))

	)
end


function k3p_pd(f, η1, η2, η3, ξ)

	u = [η1*(1-η2), η2]		#jacobian of this transformation is (1-η2)
	v = [η3*(1-ξ), ξ]		#jacobian of this transformation is (1-ξ)

	return(f(u,v)*(1-η2)*(1-ξ))
end
